ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.14 by root, Fri Dec 10 20:29:17 2010 UTC vs.
Revision 1.24 by root, Wed Dec 22 01:23:38 2010 UTC

5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10
11# perl build variables 10# perl build variables
11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
27 ;; 28 ;;
28esac 29esac
29 30
30# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
31# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
32# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
33PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
34PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
35 36
36# some configuration options for modules 37# some configuration options for modules
37export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
38#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
39export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
40 42
41# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
42# required by mkbundle 44# required by mkbundle
43STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
44 46
65 67
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68 70
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
70export LC_ALL=C # just to be on the safe side 72LC_ALL=C; export LC_ALL # just to be on the safe side
71 73
72# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
73VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
74$VERSION=0.9 76$VERSION=0.92
75 77
76BZ2=bz2 78BZ2=bz2
77BZIP2=bzip2 79BZIP2=bzip2
78 80
79fatal() { 81fatal() {
125 127
126clean() { 128clean() {
127 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
128} 130}
129 131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
136}
137
130fetch() { 138fetch() {
131 rcd "$STATICPERL" 139 rcd "$STATICPERL"
132 140
133 mkdir -p src 141 mkdir -p src
134 rcd src 142 rcd src
147 155
148 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
149 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 157 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
152 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
153 fi 162 fi
154 163
155 verblock <<EOF 164 verblock <<EOF
156unpacking perl 165unpacking perl
157EOF 166EOF
158 167
159 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
162 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
164 rmdir -p unpack 174 rmdir -p unpack
166} 176}
167 177
168# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
169sedreplace() { 179sedreplace() {
170 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
171 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
172} 209}
173 210
174configure() { 211configure() {
175 fetch 212 fetch
176 213
182configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
183EOF 220EOF
184 221
185 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
186 223
187 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
188 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
189 # I hate them 228 # I hate them for this
190 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
191 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
192 231
193 preconfigure 232 preconfigure
194 233
198 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
199 -Uusedl \ 238 -Uusedl \
200 -Uusethreads \ 239 -Uusethreads \
201 -Uuseithreads \ 240 -Uuseithreads \
202 -Uusemultiplicity \ 241 -Uusemultiplicity \
203 -Duseperlio \
204 -Uusesfio \ 242 -Uusesfio \
205 -Uuseshrplib \ 243 -Uuseshrplib \
206 -Dcppflags="$PERL_CPPFLAGS" \ 244 -A ccflags=" $PERL_CCFLAGS" \
207 -Dccflags="-g2 -fno-strict-aliasing" \ 245 -Dcc="$PERL_CC" \
208 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
209 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
210 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
211 -Dprefix="$PERL_PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
212 -Dbin="$PERL_PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
213 -Dprivlib="$PERL_PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
214 -Darchlib="$PERL_PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
215 -Uusevendorprefix \ 253 -Uusevendorprefix \
216 -Dsitelib="$PERL_PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
217 -Dsitearch="$PERL_PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
218 -Usitelibexp \
219 -Uman1dir \ 256 -Uman1dir \
220 -Uman3dir \ 257 -Uman3dir \
221 -Usiteman1dir \ 258 -Usiteman1dir \
222 -Usiteman3dir \ 259 -Usiteman3dir \
223 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
224 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
225 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
226 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
227 $PERL_CONFIGURE \ 264 $PERL_CONFIGURE \
265 -Duseperlio \
228 -dE || fatal "Configure failed" 266 -dE || configure_failure
229 267
230 sedreplace ' 268 sedreplace '
231 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
232 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
233 ' config.sh 271 ' config.sh
248building $STATICPERL/src/perl-$PERL_VERSION 286building $STATICPERL/src/perl-$PERL_VERSION
249EOF 287EOF
250 288
251 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
252 290
253 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
254 292
255 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
256} 294}
257 295
258install() { 296install() {
268 ln -sf "perl/lib/" "$STATICPERL/lib" 306 ln -sf "perl/lib/" "$STATICPERL/lib"
269 307
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf 309 rm -rf "$PERL_PREFIX" # by this rm -rf
272 310
273 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
274 312
275 rcd "$PERL_PREFIX" 313 rcd "$PERL_PREFIX"
276 314
277 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
279make || exit 317"$MAKE" || exit
280 318
281if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
282 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
283 if make perl; then 321 if "$MAKE" perl; then
284 mv perl "$PERL_PREFIX"/bin/perl 322 mv perl "$PERL_PREFIX"/bin/perl~ \
323 && rm -f "$PERL_PREFIX"/bin/perl \
324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
285 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
286 else 326 else
287 make -f Makefile.aperl map_clean 327 "$MAKE" -f Makefile.aperl map_clean
288 exit 1 328 exit 1
289 fi 329 fi
290fi 330fi
291 331
292make install UNINST=1 332"$MAKE" install UNINST=1
293EOF 333EOF
294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
295 335
296 # trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
357 for mod in "$@"; do 397 for mod in "$@"; do
358 echo 398 echo
359 echo $mod 399 echo $mod
360 ( 400 (
361 rcd $mod 401 rcd $mod
362 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
363 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
364 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
365 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
366 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
367 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
368 exit 0 408 exit 0
369 ) || exit $? 409 ) || exit $?
370 done 410 done
371} 411}
372 412
373############################################################################# 413#############################################################################
374# main 414# main
375 415
376podusage() { 416podusage() {
377 echo 417 echo
418
378 if [ -e "$PERL_PREFIX/bin/perl" ]; then 419 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 420 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 421 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 422 2>/dev/null && exit
382 fi 423 fi
424
383 # try whatever perl we can find 425 # try whatever perl we can find
384 perl -MPod::Usage -e \ 426 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 427 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 428 2>/dev/null && exit
387 429
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 430 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 431}
390 432
391usage() { 433usage() {
392 podusage 0 434 podusage 0
393} 435}
418 command="${1#--}"; shift 460 command="${1#--}"; shift
419 case "$command" in 461 case "$command" in
420 version ) 462 version )
421 echo "staticperl version $VERSION" 463 echo "staticperl version $VERSION"
422 ;; 464 ;;
423 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
424 ( "$command" ) 466 ( "$command" ) || exit
425 ;; 467 ;;
426 instsrc ) 468 instsrc )
427 ( instsrc "$@" ) 469 ( instsrc "$@" ) || exit
428 exit 470 exit
429 ;; 471 ;;
430 instcpan ) 472 instcpan )
431 ( instcpan "$@" ) 473 ( instcpan "$@" ) || exit
432 exit 474 exit
433 ;; 475 ;;
434 cpan ) 476 cpan )
435 ( install ) 477 ( install ) || exit
436 "$PERL_PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
437 exit 479 exit
438 ;; 480 ;;
439 mkbundle ) 481 mkbundle )
440 ( install ) 482 ( install ) || exit
441 bundle "$@" 483 bundle "$@"
442 exit 484 exit
443 ;; 485 ;;
444 mkperl ) 486 mkperl )
445 ( install ) 487 ( install ) || exit
446 bundle --perl "$@" 488 bundle --perl "$@"
447 exit 489 exit
448 ;; 490 ;;
449 mkapp ) 491 mkapp )
450 ( install ) 492 ( install ) || exit
451 bundle --app "$@" 493 bundle --app "$@"
452 exit 494 exit
453 ;; 495 ;;
454 help ) 496 help )
455 podusage 2 497 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines